/**
 *
 * 公共接口
 *
 */
import request from '@/utils/request';
import qs from 'qs';
const baseURL = '/nh-mcro-contract';

// 获取菜单列表
export const getMenuList = (params) => {
    return request({
        url: '/nh-farm/cp/system/menuQuery',
        method: 'get',
        params
    });
};

// 解锁接口
export function unlock(password) {
    return request({
        url: '/nh-farm/debLocking',
        method: 'POST',
        data: qs.stringify({ password }),
        headers: { 'content-type': 'application/x-www-form-urlencoded' }
    });
}
/**
 * 获取电子签章
 * @param {*} userId
 */
export function getUserSign(userId) {
    return request({
        url: '/nh-bank/signature/findByUserId?userId=' + userId,
        method: 'GET'
    });
}
/**
 * 获取用户当前主机构
 */
export function getUserHeadBankList() {
    return request({
        url: '/nh-bank/cp/bank/headBankTreeCombo?node=root',
        method: 'GET'
    });
}
/**
 * 获取县级联社机构
 */
export function getCountyBankList() {
    return request({
        url: '/nh-bank/cp/bank/userCountyBankList?node=-1',
        method: 'GET'
    });
}
// 获取推送默认选中
export function usereditForm(param) {
    return request({
        url: '/nh-bank/cp/bankSys/UsereditForm',
        method: 'get'
    });
}
// 获取推送数据
export function usersysTree(param) {
    return request({
        url: '/nh-bank/cp/bankSys/usersysTree',
        method: 'get'
    });
}
// 修改推送数据
export function editUserRole(data) {
    return request({
        url: '/nh-bank/cp/bankSys/userRoleEdit',
        method: 'POST',
        data: qs.stringify(data),
        headers: { 'content-type': 'application/x-www-form-urlencoded; charset=UTF-8' }
    });
}

export function getTodoList(search) {
    return request({
        url: '/nh-acti/todoTaskList4',
        method: 'GET',
        params: search
    });
}
/**
 * 获取用户当前机构
 */
export function getUserBankList() {
    return request({
        url: '/nh-bank/cp/bank/userBankList?node=-1',
        method: 'GET'
    });
}
// 获取省市数据
export function getBankList(parsams) {
    return request({
        url: '/nh-farm/cp/systemManagement/area/bank_list',
        method: 'GET',
        parsams
    });
}

/* ---------------------------------------------------合同-------------------------------------------------- */
// 获取合同类型数据
export function getContractType() {
    return request({
        baseURL,
        url: '/resourceManage/resourceList',
        useBase: false,
        method: 'get'
    });
}
// 机构树 old
// export const getBankLists = (areaCode) => {
//     return request({
//         url: '/nh-farm/systemManagement/area/list1',
//         method: 'get',
//         params: { areaCode }
//     });
// }

// 机构树
export const getBankLists = (params) => {
    return request({
        url: '/nh-farm/cp/systemManagement/area/list1',
        method: 'get',
        params
    });
};
// 修改密码
export function editPwd(password) {
    return request({
        url: '/nh-farm/editPwd',
        method: 'POST',
        data: password
    });
}