import request from '@/utils/request';

// 查询字典数据列表
export function listData(query) {
	return request({
		url: '/system/dict/data/list',
		method: 'get',
		params: query
	});
}

// 查询字典数据详细
export function getData(dictCode) {
	return request({
		url: '/system/dict/data/' + dictCode,
		method: 'get'
	});
}

// 根据字典类型查询字典数据信息
export function getDicts(dictType) {
	return request({
		url: 'api/dict/' + dictType,
		method: 'get'
	});
}

// 新增字典数据
export function addData(data) {
	return request({
		url: '/system/dict/data',
		method: 'post',
		data: data
	});
}

// 修改字典数据
export function updateData(data) {
	return request({
		url: '/system/dict/data',
		method: 'put',
		data: data
	});
}

// 删除字典数据
export function delData(dictCode) {
	return request({
		url: '/system/dict/data/' + dictCode,
		method: 'delete'
	});
}

// 查询
export function getDict(upId) {
	return request({
		url: '/api/dict/' + upId,
		method: 'get'
	});
}
// 新增
export function addDict(data) {
	return request({
		url: '/api/dict',
		method: 'post',
		data
	});
}
// 修改
export function editDict(data) {
	return request({
		url: '/api/dict/' + data.id,
		method: 'put',
		data
	});
}
// 修改
export function deleteDict(data) {
	return request({
		url: '/api/dict/' + data.kid,
		method: 'delete',
		data
	});
}
