import request from '@/utils/request';

// 登录
export function login(data) {
	return request({
		baseURL: '/basic-gateway',
		url: '/login',
		method: 'post',
		data
	});
}
// 验证码
export function captchaImage(params) {
	return request({
		baseURL: '/basic-gateway',
		url: '/captchaImage',
		method: 'get',
		params
	});
}

//
export function localUserInfo(params) {
	return request({
		baseURL: '/basic-gateway',
		url: '/system/localUser',
		method: 'get',
		params
	});
}
// 强制退出
export function bowlOut(data) {
	return request({
		baseURL: '/basic-gateway',
		url: '/bowlOut',
		method: 'post',
		data
	});
}

// 退出
export function logout() {
	return request({
		baseURL: '/basic-gateway',
		url: '/logout',
		method: 'delete'
	});
}

// 修改密码
export function editPwd(data) {
	return request({
		baseURL: '/basic-gateway',
		url: '/updatePwd',
		method: 'POST',
		data
	});
}

// 系统菜单权限查询
export function sysQuery(params) {
	return request({
		url: '/api/system',
		method: 'get',
		params
	});
}
