import request from '@/utils/request';

// 查询菜单列表
export function listMenu(query) {
	return request({
		url: '/api/system/list',
		method: 'get',
		params: query
	});
}

// 查询菜单详细
export function getMenu(menuId) {
	return request({
		url: '/api/system/' + menuId,
		method: 'get'
	});
}

// 新增菜单
export function addMenu(data) {
	return request({
		url: '/api/system/systemAndMenu',
		method: 'post',
		data: data
	});
}

// 修改菜单
export function updateMenu(data) {
	return request({
		url: '/api/system/systemAndMenu/' + data.kid,
		method: 'put',
		data: data
	});
}

// 删除菜单
export function delMenu(menuId) {
	return request({
		url: '/api/system/' + menuId,
		method: 'delete'
	});
}
