import request from '@/utils/request';

// 查询角色列表
export function listRole(query) {
	return request({
		url: '/system/roles',
		method: 'get',
		params: query
	});
}

// 查询角色详细
export function getRole(roleId) {
	return request({
		url: '/system/roles/' + roleId,
		method: 'get'
	});
}

// 新增角色
export function addRole(data) {
	return request({
		url: '/system/role',
		method: 'post',
		data: data
	});
}
export function roleList(params) {
	return request({
		url: '/system/roleList',
		method: 'get',
		params
	});
}

// 修改角色
export function updateRole(data) {
	return request({
		url: '/system/role/' + data.kid,
		method: 'put',
		data: data
	});
}

// 角色数据权限
export function dataScope(data) {
	return request({
		url: '/system/role/dataScope',
		method: 'put',
		data: data
	});
}
// 删除角色
export function delRole(roleId) {
	return request({
		url: '/system/roles/' + roleId,
		method: 'delete'
	});
}
