import { stringToByte } from '@/utils/nhUtils.js';
import { getUser } from '@/utils/user.js';
export default {
	data() {
		return {
			moduleName: '',
			replaceId: 0,
			updateToken: true,
			token: {},
			params: {},
			uploadUrl: '',
			parentId: -1,
			parentData: [],
			parentProps: {
				value: 'storage_id',
				label: 'name',
				children: 'children',
				checkStrictly: true,
				emitPath: false
			}
		};
	},
	methods: {
		// 获取 Token
		getToken() {
			// 检测Token是否过期
			// const nowTime = Math.round(new Date() / 1000) + 100
			// if (this.token.expires !== 0 && nowTime > this.token.expires) {
			//   this.updateToken = true
			// }

			return new Promise((resolve) => {
				// 是否需要更新
				if (!this.updateToken) {
					return resolve();
				}

				this.params = {
					path: getUser().areaCode + '/nh-sale',
					...this.params
				};
				this.token = {
					file_size: '500kb',
					upload_url: this.action
				};
				this.uploadUrl = this.token.upload_url;
				// if (this.replaceId) {
				//   replaceUploadItem(this.replaceId)
				//     .then(res => {
				//       this.token = res.data || {}
				//       this.uploadUrl = this.token.token.upload_url.upload_url
				//       this.updateToken = false
				//       resolve()
				//     })
				// } else {

				// getUploadToken(this.moduleName)
				//   .then(res => {
				//     this.token = res.data || {}
				//     this.uploadUrl = this.token.token.upload_url.upload_url
				//     this.updateToken = false
				//     resolve()
				//   })
				// }
			});
		},
		// 删除资源
		handleRemove(file, fileList) {
			if (file.status === 'success' && file.response) {
				const response = file.response.data;
				if (response && response[0].storage_id) {
					// const storageId = response[0].storage_id
					// delStorageList(Array.isArray(storageId) ? storageId : [storageId])
				}
			}

			this.$emit('upload', fileList);
		},
		// 资源预览
		handlePreview(file) {
			if (file.status === 'success') {
				const response = file.response.data;
				if (response.length && response[0].type === 0) {
					this.$preview(response[0].url);
					return;
				}
			}

			this.$message.warning('当前模式或资源不支持预览');
		},
		// 上传文件之前的钩子
		handleBeforeUpload(file) {
			// if (!this.token || !this.uploadUrl) {
			//   this.$message.error('上传组件初始化中或配置错误')
			//   return false
			// }
			const fielMaxSize = stringToByte(this.token.file_size);
			if (fielMaxSize > 0 && file.size > fielMaxSize) {
				this.$message.error(`上传资源大小不能超过 ${fielMaxSize}`);
				return false;
			}

			const suffix = file.name.toLowerCase().split('.').splice(-1).toString();
			const allImageType =
				'.svgz,.pjp,.jfj,.ico,.tiff,.avif,.svg,.jpg,.tif,.gif,.png,.xbm,.pjpeg,.bmp,.wbp';

			const checkSuffix = this.accept === 'image/*' ? allImageType : this.accept;
			if (checkSuffix.indexOf(suffix) === -1) {
				this.$message.error('上传资源的文件后缀不允许上传');
				return false;
			}
			// 自动上传时,"确定"按钮将改变状态
			if (this.autoUpload) {
				this.loading = true;
			}
		},
		// 文件上传成功时的钩子
		handleSuccess(response, file, fileList) {
			//   && response.result
			if (response.code === 200) {
				this.$emit('upload', fileList);
				this.handleChange(fileList);
				this.$notify({
					title: '提示',
					message: '附件上传成功',
					type: 'success'
				});
				return;
			}

			this.handleError(response.message, file, fileList);
		},
		// 文件上传失败时的钩子
		handleError(_err, file, fileList) {
			this.$message.error(`资源：${file.name} 上传失败`);

			for (let i = fileList.length - 1; i >= 0; i--) {
				if (file === fileList[i]) {
					fileList.splice(i, 1);
					this.$emit('upload', fileList);
					break;
				}
			}

			this.handleChange(fileList);
		},
		// 文件超出个数限制时的钩子
		handleExceed(files, fileList) {
			if (fileList.length >= this.limit) {
				this.$message.warning(`最多只能上传 ${this.limit} 个文件`);
				return;
			}

			if (files.length + fileList.length > this.limit) {
				const count = this.limit - fileList.length;
				this.$message.warning(`上传数量超出限制，最多还能选择 ${count} 个文件`);
			}
		},
		// "确定"按钮状态转换
		handleChange(fileList) {
			if (this.autoUpload) {
				if (Object.keys(fileList).every((item) => fileList[item].status === 'success')) {
					this.loading = false;
				}
			}
		},
		// 获取可选目录(外部不传入storageId时启用)
		getDirectory() {
			// if (this.storageId !== null || this.parentData.length > 0) {
			// }
			//   getStorageDirectorySelect()
			//     .then(res => {
			//       this.parentData =  1//util.formatDataToTree(res.data.list, 'storage_id')
			//       this.parentData.unshift({
			//         storage_id: -1,
			//         parent_id: 0,
			//         name: '根目录'
			//       })
			//       this.parentId = res.data.default || -1
			//     })
		}
	}
};
