/**
 * v-hasPermi 操作权限处理
 */

import store from '@/store';

export default {
	// eslint-disable-next-line no-unused-vars
	inserted(el, binding, vnode) {
		const { value } = binding;
		const allpermission = '*:*:*';
		const permissions = store.state.permission.authKey;

		if (value && value instanceof Array && value.length > 0) {
			const permissionFlag = value;

			const hasPermissions = permissions.some((permission) => {
				return allpermission === permission || permissionFlag.includes(permission);
			});

			if (!hasPermissions) {
				el.parentNode && el.parentNode.removeChild(el);
			}
		} else {
			throw new Error(`请设置操作权限标签值`);
		}
	}
};
