/*
 * @Date: 2023-06-19 14:57:03
 * @LastEditors: bbcef 961166897@qq.com
 * @LastEditTime: 2023-07-11 11:15:06
 * @FilePath: \provincial_platform_fms\src\main.js
 */
import Vue from 'vue';

import App from './App';
import store from './store';
import router from './router';
import directive from './directive'; // directive
import plugins from './plugins'; // plugins

// 字典数据组件
import DictData from '@/components/DictData';
Vue.use(directive);
Vue.use(plugins);
DictData.install();
// Vue.config.productionTip = false;

// 加载本地数据
store.commit('loadCurrSelectBank');
store.dispatch('loadUserInfo');
store.commit('loadSystemTitle');
store.commit('loadSystemTitlPlat');
store.dispatch('getPlatformName');
store.dispatch('getPlatformNamePlat');

store.commit('loadCurrAccountBook');
store.commit('loadCurrAccountMessage');

store.commit('loadSystem');
store.dispatch('footerTagsView/loadFooterTagsView');
store.commit('loadPermissions');
store.commit('loadRoles');

setTimeout(() => {
  store.commit('loadAuthKey');
  store.dispatch('loadSystemMenu');
}, 500)
new Vue({
	router,
	store,
	mounted() {},
	render: (h) => h(App)
}).$mount('#app');
