/*
 * @Author: 刘智超
 * @Date: 2022-09-01 17:13:58
 * @LastEditors: 刘智超
 * @LastEditTime: 2022-10-27 15:30:52
 * @Description:
 */
import { isEmpty, easyRegexpPhone } from '@/utils/utils';
import { isIdCard, isHan } from '@/utils/validate';

// 电话
var validatorPhone = (rule, value, callback) => {
	if (isEmpty(value)) {
		return callback();
	}
	if (!easyRegexpPhone.test(value)) {
		return callback(new Error('请正确输入号码'));
	} else {
		callback();
	}
};
// 身份证号码
var validatorIdCard = (rule, value, callback) => {
	if (isEmpty(value)) {
		return callback();
	}
	if (!isIdCard(value)) {
		return callback(new Error('请正确输入身份证号码'));
	} else {
		callback();
	}
};
// 汉字
var validHan = (rule, value, callback) => {
	if (isEmpty(value)) {
		return callback();
	}
	if (!isHan(value)) {
		return callback(new Error('请输入汉字'));
	} else {
		callback();
	}
};
// 年龄
var validatorAge = (rule, value, callback) => {
	if (value < 0 || value > 150) {
		return callback(new Error('请正确输入年龄'));
	} else {
		callback();
	}
};
const baseRules = {
	min1Andmax8: { min: 1, max: 8, message: '长度在 1 到 8 个字符', trigger: 'blur' },
	max8: { max: 8, message: '长度最大为 8 个字符', trigger: 'blur' },
	max500: { max: 500, message: '长度最大为 500 个字符', trigger: 'blur' },
	email: { type: 'email', message: '请输入正确的邮箱地址', trigger: ['blur', 'change'] },
	phone: { validator: validatorPhone, trigger: 'blur' },
	han: { validator: validHan, trigger: 'blur' },
	idCard: { validator: validatorIdCard, trigger: 'blur' },
	age: { validator: validatorAge, trigger: 'blur' }
};
export default baseRules;
