import { getAcconutName } from '@/utils/user.js';
import { timeFormat, getMaxDay } from '@/utils/utils';

const model = {
	// 禁用指定年份
	disabledDateYearArr(time, arr = []) {
		if (arr.length > 0) {
			for (let index = 0; index < arr.length; index++) {
				const e = arr[index];
				const year = Number(timeFormat(time.getTime(), 'yyyy'));
				if (year === e) {
					return true;
				}
			}
		} else {
			// console.error('没有指定年份数组');
			return false;
		}
	},
	disabledDateYearCos(time, year) {
		const nowLastTime = new Date(`${year}-12-31`);
		return time.getTime() > nowLastTime;
	},
	disabledDateYearEnd(time) {
		const nowDate = Number(getAcconutName());
		// const prevDate = nowDate - 1;

		const nowLastTime = new Date(`${nowDate}-12-31`);
		// const prevLastTime = new Date(`${prevDate}-12-31`);

		return time.getTime() > nowLastTime;
	},
	disabledDateYear(time) {
		const nowDate = Number(getAcconutName());
		const prevDate = nowDate - 1;

		const nowLastTime = new Date(`${nowDate}-12-31`);
		const prevLastTime = new Date(`${prevDate}-12-31`);

		return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	},
	// disabledDateMonth(time){
	//   let nowDate = Number(getAcconutName());
	//   let prevDate = nowDate - 1;
	//   let nowMonth = Number(timeFormat(time,'MM'));
	//   let nowDay = getMaxDay(Number(timeFormat(time,'M')));
	//   let nowLastTime = new Date(`${nowDate}-${nowMonth}-${nowDay}`);
	//   let prevLastTime = new Date(`${prevDate}-12-31`);

	//   return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	// },

	disabledDateMonth(time, yearMonth) {
		const nowDate = Number(getAcconutName());
		const prevDate = nowDate - 1;
		const nowMonths = yearMonth.split('-')[1];
		const nowMonth = Number(timeFormat(yearMonth, 'MM'));
		const month = nowMonths.split('')[0] === 0 ? nowMonths.split('')[1] : nowMonth;
		const nowDay = getMaxDay(Number(month));

		const nowLastTime = new Date(`${nowDate}-${nowMonths}-${nowDay}`);
		const prevLastTime = new Date(`${prevDate}-12-31`);
		return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	},

	disabledYearMonth(time, yearMonth) {
		const nowDate = Number(getAcconutName());
		// const prevDate = nowDate - 1;
		const nowMonths = yearMonth.split('-')[1];
		// const nowMonth = Number(timeFormat(yearMonth, 'MM'));
		// const month = nowMonths.split('')[0] === 0 ? nowMonths.split('')[1] : nowMonth;
		// const nowDay = getMaxDay(Number(month));

		const nowLastTime = new Date(`${nowDate}-${nowMonths}`);
		const prevLastTime = new Date(`${nowDate}-01`);
		return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	},
	disabledYearMonthNo(time, yearMonth) {
		const nowDate = Number(getAcconutName());
		// const prevDate = nowDate - 1;
		const nowMonths = yearMonth.split('-')[1];
		// const nowMonth = Number(timeFormat(yearMonth, 'MM'));
		// const month = nowMonths.split('')[0] === 0 ? nowMonths.split('')[1] : nowMonth;
		// const nowDay = getMaxDay(Number(month));

		let nowMonthss = Number(nowMonths) === 12 ? 11 : Number(nowMonths) - 1;
		nowMonthss = nowMonthss < 10 ? '0' + nowMonthss : nowMonthss;
		const nowLastTime = new Date(`${nowDate}-${nowMonthss}`);
		const prevLastTime = new Date(`${nowDate}-01`);
		return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	},
	disabledYearMonthEnd(time, yearMonth) {
		const nowDate = Number(getAcconutName());
		const nowMonths = yearMonth.split('-')[1];
		let nowMonthss = Number(nowMonths) === 12 ? 12 : Number(nowMonths) + 1;
		nowMonthss = nowMonthss < 10 ? '0' + nowMonthss : String(nowMonthss);

		let prevLastTime;
		if (nowMonthss === '12') {
			// const nextYear = Number(nowDate) + 1;
			prevLastTime = new Date(`${nowDate}-12-31`);
		} else {
			prevLastTime = new Date(`${nowDate}-12`);
		}
		const nowLastTime = new Date(`${nowDate}-${nowMonthss}`);
		// prevLastTime = new Date(`${nowDate}-12`);
		return time.getTime() < nowLastTime || time.getTime() > prevLastTime;
	},

	disabledYearMonthDay(time, yearMonth) {
		const nowDate = Number(getAcconutName());
		// const prevDate = nowDate - 1;
		const nowMonths = yearMonth.split('-')[1];
		// const nowMonth = Number(timeFormat(yearMonth, 'MM'));
		// const month = nowMonths.split('')[0] === 0 ? nowMonths.split('')[1] : nowMonth;
		// const nowDay = getMaxDay(Number(month));

		const nowLastTime = new Date(`${nowDate}-${nowMonths}-${getMaxDay(nowMonths)}`);
		const prevLastTime = new Date(`${nowDate}-01-01`);
		return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	},

	disabledCurrDate(time, yearMonth) {
		const currYear = Number(timeFormat(null, 'yyyy'));
		const nowDate = Number(getAcconutName());
		const prevDate = nowDate - 1;
		const nowMonths = yearMonth.split('-')[1];
		const nowMonth = Number(timeFormat(yearMonth, 'MM'));
		const month = nowMonths.split('')[0] === 0 ? nowMonths.split('')[1] : nowMonth;
		// eslint-disable-next-line no-unused-vars
		const nowDay = getMaxDay(Number(month));

		let nowLastTime;
		if (currYear !== nowDate) {
			nowLastTime = new Date(`${nowDate}-12-31`);
		} else {
			nowLastTime = new Date();
		}
		// new Date(`${nowDate}-${nowMonths}-${nowDay}`);
		const prevLastTime = new Date(`${prevDate}-12-31`);
		return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	},

	disabledYearMonths(time, yearMonth) {
		const year = Number(yearMonth.split('-')[0]);
		const nowMonths = Number(yearMonth.split('-')[1]);
		const prevDate =
			nowMonths === 1 ? `${year - 1}-12-31 08:00:00` : `${year}-${nowMonths}-01 00:00:00`;
		const nowLastTime = new Date(`${yearMonth}-${getMaxDay(nowMonths)}`);
		const prevLastTime = new Date(prevDate);
		return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	},
	disabledYearMonthsEnd(time, yearMonth) {
		const year = Number(yearMonth.split('-')[0]);
		const nowMonths = Number(yearMonth.split('-')[1]);
		const prevDate =
			nowMonths === 1 ? `${year - 1}-12-31 08:00:00` : `${year}-01-01 00:00:00`;
		const nowLastTime = new Date(`${yearMonth}-${getMaxDay(nowMonths)}`);
		const prevLastTime = new Date(prevDate);
		return time.getTime() > nowLastTime || time.getTime() < prevLastTime;
	},

	disabledYear(time, year) {
		const nowLastTime = new Date(`${year}-12-31`);
		const nowPrevTime = new Date(`${year - 1}-12-31`);
		return time.getTime() > nowLastTime || time.getTime() < nowPrevTime;
	}
};
export default model;
