import Cookies from 'js-cookie';
// Element
import ElementUI from 'element-ui';
import '@/config/style.css';
import 'element-ui/lib/theme-chalk/index.css';
import '@/assets/styles/element-variables.scss';
import '@/assets/styles/index.scss'; // global css
import '@/assets/styles/ruoyi.scss'; // ruoyi css

import { download } from '@/utils/request';
import { validForbid } from '@/utils/utils';
import D2Container from '@/components/d2-container/index.js';
import D2Footer from '@/components/d2-footer/index.vue';
import D2Header from '@/components/bc_header_search/index.vue';
import ClDialog from '@/components/cl-dialog/index';
import pluginPreview from '@/components/cs-preview/index';
import  {tableBaseStyle} from  '@/element-setting/index'; // ruoyi css

import {
	parseTime,
	resetForm,
	addDateRange,
	selectDictLabel,
	selectDictLabels,
	handleTree
} from '@/utils/ruoyi';
import Print from 'vue-print-nb'
import pluginPermission from './permission';
// 分页组件
import Pagination from '@/components/Pagination';
import CsNumberInput from '@/components/cs-number-input/';


// 自定义表格工具组件
import RightToolbar from '@/components/RightToolbar';
// 文件上传组件
import FileUpload from '@/components/FileUpload';
// 图片上传组件
import ImageUpload from '@/components/ImageUpload';
// 图片预览组件
import ImagePreview from '@/components/ImagePreview';
// 字典标签组件
import DictTag from '@/components/DictTag';
import D2Icon from '@/components/d2-icon/';
import CsPrint from '@/components/cs-print/';
import CsTable from '@/components/cs-table/';
import CsPrintTable from '@/components/cs-print-table/';
import PrintPlugin from '@/components/print-plugin';
import CsUpload from '@/components/cs-upload/';
import CsPhoto from '@/components/cs-photo/';
import CssPhoto from '@/components/css-photo/';
import BcTitle from '@/components/bc_title/';



import Prints from './print.js';
export default {
	async install(Vue) {
		// Element
		Vue.use(ElementUI, {
			size: Cookies.get('size') || 'medium' // set element-ui default size
		});
		Vue.use(pluginPermission);
		Vue.use(Prints);
    Vue.use(Print);
		Vue.use(pluginPreview);

		// 全局方法挂载
		// Vue.prototype.getDicts = getDicts;
		Vue.prototype.parseTime = parseTime;
		Vue.prototype.resetForm = resetForm;
		Vue.prototype.addDateRange = addDateRange;
		Vue.prototype.selectDictLabel = selectDictLabel;
		Vue.prototype.selectDictLabels = selectDictLabels;
		Vue.prototype.download = download;
		Vue.prototype.handleTree = handleTree;
		Vue.prototype.validForbid = validForbid;
		Vue.prototype.tableBaseStyle = tableBaseStyle;

		// 全局组件挂载
		Vue.component('DictTag', DictTag);
		Vue.component('Pagination', Pagination);
		Vue.component('RightToolbar', RightToolbar);
		Vue.component('FileUpload', FileUpload);
		Vue.component('ImageUpload', ImageUpload);
		Vue.component('ImagePreview', ImagePreview);
		Vue.component('CsNumberInput', CsNumberInput);

		Vue.component('D2Icon', D2Icon);
		Vue.component('D2Container', D2Container);
		Vue.component('D2Footer', D2Footer);
		Vue.component('D2Header', D2Header);
		Vue.component('ClDialog', ClDialog);
		Vue.component('CsPrint', CsPrint);
		Vue.component('CsPrintTable', CsPrintTable);
		Vue.component('PrintPlugin', PrintPlugin);
		Vue.component('CsTable', CsTable);
		Vue.component('CsUpload', CsUpload);
		Vue.component('CsPhoto', CsPhoto);
		Vue.component('BcTitle', BcTitle);
		Vue.component('CssPhoto', CssPhoto);


	}
};
