import Vue from 'vue';
import { timeFormat } from '@/utils/utils';
var dicNames;
Vue.filter('phone', function (value) {
	// 全局方法 Vue.filter() 注册一个自定义过滤器,必须放在Vue实例化前面
	// eslint-disable-next-line eqeqeq
	if (!value || value === '') {
		return '';
	}
	value = value + '';
	value = value.substring(0, 3) + '****' + value.substring(7);
	return value;
});

Vue.filter('moneyWang', function (value) {
	// 全局方法 Vue.filter() 注册一个自定义过滤器,必须放在Vue实例化前面
	// eslint-disable-next-line eqeqeq
	let result = 0;
	if (!value || value === '') {
		return '-';
	}
	if (value === 0) {
		result = 1;
	}
	result = (Number(value) / 10000).toFixed(2);
	return result;
});

Vue.filter('money', function (value) {
	// 全局方法 Vue.filter() 注册一个自定义过滤器,必须放在Vue实例化前面
	// eslint-disable-next-line eqeqeq
	let result = '';
	if (!value || value === '') {
		result = '-';
	} else if (value === 0) {
		result = value + '';
	} else {
		// result = value.toFixed(2).toLocaleString('en-US');
		value = Number(value);
		result = value
			.toFixed(2)
			.replace(/(\d)(?=(\d{3})+\.)/g, ($0, $1) => {
				return $1 + ',';
			})
			.replace(/\.$/, '');
	}
	return result;
});
Vue.filter('gender', function (value) {
	// 全局方法 Vue.filter() 注册一个自定义过滤器,必须放在Vue实例化前面
	// eslint-disable-next-line eqeqeq
	let result = '';
	if (!value || value === '') {
		result = '-';
	} else if (value === 1) {
		result = '男';
	} else if (value === 2) {
		result = '女';
	} else if (value === 3) {
		result = '未知';
	}
	return result;
});
/**
 * 日期过滤
 */
Vue.filter('dateFiltering', function (value, format = 'yyyy-MM-dd') {
	// 全局方法 Vue.filter() 注册一个自定义过滤器,必须放在Vue实例化前面
	// eslint-disable-next-line eqeqeq
	let result = '';
	if (!value || value === '') {
		result = '-';
	} else {
		result = timeFormat(new Date(value).getTime(), format);
	}
	return result;
});
/**
 * 数组过滤返回对应的值
 * list 数据源
 * dicCode 值与数据源中那个字段对应
 * dicName 返回数据源的那个字段
 */
Vue.filter('nameFiltering', function (value, list = [], dicCode, dicName,children='children') {
	// 全局方法 Vue.filter() 注册一个自定义过滤器,必须放在Vue实例化前面
	// eslint-disable-next-line eqeqeq
	let result = '';
	if (!value || value === '') {
		result = '-';
	} else {
    traverseArr(list,dicCode,value,children);
    if(dicNames){
      result = dicNames[`${dicName}`]
    }
    /* list.map((item) => {
			if (item[`${dicCode}`] === value) {
				result = item[`${dicName}`];
			}
		}); */
		// result = timeFormat(new Date(value).getTime(), format);
	}

	return result;
});

const traverseArr = (list,dicCode,value,children) => {
  let res = [];
  try {
    list.forEach(e => {
      if(e[dicCode] === value){
        res = e;
        throw new Error('LoopInterrupt');
      }else {
        if(e[children]){
          traverseArr(e[children],dicCode,value,children)
        }
      }
    })
  }catch(e) {
    dicNames = res;
  }

}
