import config from '@/config';
import { encryptionCrypto, decryptCrypto } from '@/utils/aes';

export function setUser (userInfo) {
  if (userInfo) {
    var now = new Date()
    userInfo.sessionTime = now.getTime()
  }
  const data = encryptionCrypto(config.loginKey, JSON.stringify(userInfo));
  localStorage.setItem('userInfo', data);
  // sessionStorage.setItem('userInfo', JSON.stringify(userInfo))
}

export function isexitUser () {
  var user = getUser();
  if (user) {
    return true
  }
  return false
}

export function getUser () {
  const userInfo = localStorage.getItem('userInfo');
  if (userInfo) {
    // 校验是否失效 3 小时
    const data = decryptCrypto(config.loginKey, userInfo);
    var user = JSON.parse(data);
    var expire = 3 * 60 * 60 * 1000
    var now = new Date().getTime();
    var lastTime = user.sessionTime
    if (now - lastTime > expire) {
      // 过期了
      removeUser()
      return null
    } else {
      // 更新时间
      setUser(user)
      return user
    }
  }
  return null
}

export function setId (bankId) {
  bankId = String(bankId);
  const data = encryptionCrypto(config.loginKey, bankId);
  localStorage.setItem('bank_id', data);
}

export function getId () {
  let data = localStorage.getItem('bank_id');
  if (data) {
    data = decryptCrypto(config.loginKey, data);
  }
  return data;
}
export function setName (bankName) {
  const data = encryptionCrypto(config.loginKey, bankName);
  localStorage.setItem('bank_name', data);
}

export function getName () {
  let data = localStorage.getItem('bank_name');
  if (data) {
    data = decryptCrypto(config.loginKey, data);
  }
  return data;
}
export function getKid () {
  let data = localStorage.getItem('banKid');
  if (data) {
    data = decryptCrypto(config.loginKey, data);
  }
  return data;
}
// 机构等级
export function setBankLevel (bankLevel) {
  bankLevel = String(bankLevel);
  const data = encryptionCrypto(config.loginKey, bankLevel);
  localStorage.setItem('bank_level', data);
}

export function getBankLevel () {
  let data = localStorage.getItem('bank_level');
  if (data) {
    data = decryptCrypto(config.loginKey, data);
  }
  return data;
}

export function setAreaKid (areaKid) {
  areaKid = String(areaKid);
  const data = encryptionCrypto(config.loginKey, areaKid);
  localStorage.setItem('area_kid', data);
}

export function getAreaKid () {
  let data = localStorage.getItem('area_kid');
  if (data) {
    data = decryptCrypto(config.loginKey, data);
  }
  return data;
}

// 本地帐套
export function setAcconutName (acconutName) {
  const data = encryptionCrypto(config.loginKey, acconutName);
  localStorage.setItem('acconutName', data);
}
export function getAcconutName () {
  let data = localStorage.getItem('acconutName');
  if (data) {
    data = decryptCrypto(config.loginKey, data);
  }
  return data;
}
// 本地帐套状态
export function setAcconutState (acconutState) {
  const data = encryptionCrypto(config.loginKey, acconutState);
  localStorage.setItem('acconutState', data);
}
export function getAcconutState () {
  let data = localStorage.getItem('acconutState');
  if (data) {
    data = decryptCrypto(config.loginKey, data);
  }
  return data;
}

// 当前登录人菜单权限
export function setMenuPermissions (menu) {
  const data = encryptionCrypto(config.loginKey, JSON.stringify(menu));
  localStorage.setItem('menuPermissions', data);
}
export function getMenuPermissions () {
  let data = localStorage.getItem('menuPermissions');
  if (data) {
    data = decryptCrypto(config.loginKey, data);
    data = JSON.parse(data);
  } else {
    data = `/${process.env.VUE_APP_SYSTEM_CODE.toLowerCase()}/frame/frame.html`;
  }

  return data;
}

export function removeUser () {
  localStorage.clear();
  sessionStorage.clear();
}
