export const urlEncode = function (param, key, encode) {
	if (param == null) return '';
	var paramStr = '';
	var t = typeof param;
	if (t === 'string' || t === 'number' || t === 'boolean') {
		paramStr += '&' + key + '=' + (encode == null || encode ? encodeURIComponent(param) : param);
	} else {
		for (var i in param) {
			var k = key == null ? i : key + (param instanceof Array ? '[' + i + ']' : '.' + i);
			paramStr += urlEncode(param[i], k, encode);
		}
	}
	return paramStr;
};
//
export const isIE = () => {
	// return !Vue.prototype.$isServer && !isNaN(Number(document.documentMode))
	return !isNaN(Number(document.documentMode));
};
// 预览图片地址
export const previewUrl = (id) => `/nh-cloud/img/${id}`;
// 时间格式化
export const format = function (date, format) {
	date = new Date(date);
	const o = {
		'M+': date.getMonth() + 1,
		'd+': date.getDate(),
		'H+': date.getHours(),
		'm+': date.getMinutes(),
		's+': date.getSeconds(),
		'q+': Math.floor((date.getMonth() + 3) / 3), // 季度
		'f+': date.getMilliseconds() // 毫秒
	};
	if (/(y+)/.test(format)) {
		format = format.replace(RegExp.$1, date.getFullYear() + '').substr(4 - RegExp.$1.length);
	}
	// eslint-disable-next-line no-unused-vars
	for (const k in o) {
		if (new RegExp('(' + k + ')').test(format)) {
			format = format.replace(
				RegExp.$1,
				RegExp.$1.length === 1 ? o[k] : ('00' + o[k]).substr(('' + o[k]).length)
			);
		}
	}
	return format;
};

//
export const stringToByte = function (val) {
	const exp = '(^[0-9\\.]+)(\\w+)';
	const result = String(val).match(exp);

	if (!result) {
		return 0;
	}

	const size = result[1];
	const suffix = result[2].toLocaleUpperCase();

	const a = { B: 0, KB: 1, MB: 2, GB: 3, TB: 4, PB: 5 };
	const b = { B: 0, K: 1, M: 2, G: 3, T: 4, P: 5 };

	// eslint-disable-next-line no-prototype-builtins
	const pos = a.hasOwnProperty(suffix) && a[suffix] !== 0 ? a[suffix] : b[suffix];
	return Math.round(size * Math.pow(1024, pos));
};

export const getMse = () => {
	const noeDate = new Date();
	// let y = noeDate.getFullYear()
	const m = noeDate.getMonth() + 1; // <= 9 ? '0' + (noeDate.getMonth + 1) : (noeDate.getMonth + 1)
	// let d = noeDate.getDate()  // <= 9 ? '0' + noeDate.getDate() : noeDate.getDate()
	const dNums = ['1', '3', '5', '7', '8', '10', '12'];
	const sNums = ['4', '6', '9', '11'];
	if (dNums.indexOf(String(m)) > -1) {
		return ['01', '31'];
	} else if (sNums.indexOf(String(m)) > -1) {
		return ['01', '30'];
	} else {
		return ['01', '28'];
	}
};
/**
 * 生成 GUID
 * @returns {string}
 */
export const guid = () => {
	const s = [];
	const hexDigits = '0123456789abcdef';

	for (let i = 0; i < 36; i++) {
		s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
	}

	s[14] = '4'; // bits 12-15 of the time_hi_and_version field to 0010
	s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
	s[8] = s[13] = s[18] = s[23] = '-';

	return s.join('');
};

// 获取 href 指定参数
export const getHrefParams = (name) => {
	var rs = new RegExp('(^|)' + name + '=([^&]*)(&|$)', 'gi').exec(window.document.location.href);
	var tmp;
	if (tmp === rs) {
		return decodeURI(tmp[2]);
	}
	// parameter cannot be found
	return '';
};

// 秒格式化
export const SecondToDate = (msd) => {
	var time = msd;
	if (time != null && time !== '') {
		if (time > 60 && time < 60 * 60) {
			time =
				parseInt(time / 60.0) +
				'分' +
				parseInt((parseFloat(time / 60.0) - parseInt(time / 60.0)) * 60) +
				'秒';
		} else if (time >= 60 * 60 && time < 60 * 60 * 24) {
			time =
				parseInt(time / 3600.0) +
				'时' +
				parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) +
				'分' +
				parseInt(
					(parseFloat((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) -
						parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60)) *
						60
				) +
				'秒';
		} else if (time >= 60 * 60 * 24) {
			time =
				parseInt(time / 3600.0 / 24) +
				'天' +
				parseInt((parseFloat(time / 3600.0 / 24) - parseInt(time / 3600.0 / 24)) * 24) +
				'时' +
				parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) +
				'分' +
				parseInt(
					(parseFloat((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) -
						parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60)) *
						60
				) +
				'秒';
		} else {
			time = parseInt(time) + '秒';
		}
	}
	return time;
};

// 不规则时间格式化
export const dateForame = (time) => {
	time = String(time);
	const y = time.substring(0, 4);
	const M = time.substring(4, 6);
	const d = time.substring(6, 8);
	const h = time.substring(8, 10);
	const m = time.substring(10, 12);
	const s = time.substring(12, 14);

	return `${y}-${M}-${d} ${h}:${m}:${s}`;
};

// 拷贝
export function getType(obj) {
	// tostring会返回对应不同的标签的构造函数
	var toString = Object.prototype.toString;
	var map = {
		'[object Boolean]': 'boolean',
		'[object Number]': 'number',
		'[object String]': 'string',
		'[object Function]': 'function',
		'[object Array]': 'array',
		'[object Date]': 'date',
		'[object RegExp]': 'regExp',
		'[object Undefined]': 'undefined',
		'[object Null]': 'null',
		'[object Object]': 'object'
	};
	if (obj instanceof Element) {
		return 'element';
	}
	return map[toString.call(obj)];
}
export const deepClone = (data) => {
	var type = getType(data);
	var obj;
	if (type === 'array') {
		obj = [];
	} else if (type === 'object') {
		obj = {};
	} else {
		// 不再具有下一层次
		return data;
	}
	if (type === 'array') {
		for (var i = 0, len = data.length; i < len; i++) {
			obj.push(deepClone(data[i]));
		}
	} else if (type === 'object') {
		for (var key in data) {
			obj[key] = deepClone(data[key]);
		}
	}
	return obj;
};

export const treeToArr = (data, list = []) => {
	data.map((e) => {
		if (e.path) {
			list.push(e.path);
			if (e.children) {
				treeToArr(e.children, list);
			}
			return list;
		} else {
			if (e.children) {
				treeToArr(e.children, list);
			}
		}
	});
	return list;
};
